# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with xmlgraphics

%define section free
%define bname   springsource-util

%define upstream_tag .RELEASE
%define upstream_version %{version}%{?upstream_tag}

Name:           springsource-util
Summary:        Spring Util
Version:        2.0.0
Release:        1%{?dist}
Epoch:          0
License:        ASL 2.0
Group:          Development/Libraries/Application Frameworks
URL:            http://www.springframework.org/
# git clone git://git.springsource.org/dm-server/util.git
# mkdir springsource-util-2.0.0.RELEASE
# cd util
# git archive 2.0.0.RELEASE | tar -x -C ../springsource-util-2.0.0.RELEASE
# cd ..
# tar czf ../SOURCES/springsource-util-2.0.0.RELEASE.tgz springsource-util-2.0.0.RELEASE/



Source0:        %{name}-%{upstream_version}.tgz
Source1:        %{name}-ivy-cache.tgz

Source11:       com.springsource.util.common-2.0.0.RELEASE.pom
Source12:       com.springsource.util.env-2.0.0.RELEASE.pom
Source13:       com.springsource.util.io-2.0.0.RELEASE.pom
Source14:       com.springsource.util.jmx-2.0.0.RELEASE.pom
Source15:       com.springsource.util.math-2.0.0.RELEASE.pom
Source16:       com.springsource.util.osgi-2.0.0.RELEASE.pom
Source17:       com.springsource.util.parser.manifest-2.0.0.RELEASE.pom
Source18:       com.springsource.util.test-2.0.0.RELEASE.pom


Patch0:         springsource-util-ivysettings.patch
Patch1:         springsource-util-spring-build-ivysettings.patch
Patch2:         springsource-util-jmx-template.patch
Patch3:         springsource-util-build-versions.patch
Patch4:         springsource-util-build-util-build.patch
Patch5:         springsource-util-spring-build-aspect-common.patch
Patch6:         springsource-util-spring-build-aspect-quality.patch

BuildArch:      noarch
BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-1.6.0-devel
BuildRequires:  ant >= 0:1.7.1
#BuildRequires:  ant-trax >= 0:1.7.1
BuildRequires:  ant-junit >= 0:1.7.1
#BuildRequires:  ant-nodeps >= 0:1.7.1
BuildRequires:  junit4 >= 0:4.7

#BuildRequires:  springsource-bundlor
#BuildRequires:  springsource-osgi-medic
#BuildRequires:  springsource-util
BuildRequires:  apache-commons-logging
BuildRequires:  aspectj
BuildRequires:  easymock2
BuildRequires:  ecj3
BuildRequires:  junit4
BuildRequires:  objectweb-asm
BuildRequires:  slf4j
#BuildRequires:  springframework-build
BuildRequires:  spring2-beans
BuildRequires:  spring2-core
#BuildRequires:  springframework-xml
BuildRequires:  ws-commons-XmlSchema

Requires:       java >= 0:1.6.0

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Spring is a layered Java/J2EE application framework, 
based on code published in Expert One-on-One J2EE 
Design and Development by Rod Johnson (Wrox, 2002). 

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%package devel
Summary:        Source jars for %{name}
Group:          Development/Java

%description devel
%{summary}.

%prep
%setup -q -n %{name}-%{upstream_version}
tar xzf %{SOURCE1}

chmod -R go=u-w *

%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
%patch5 -b .sav5
%patch6 -b .sav6

# rm ivy-cache/repository/com.springsource.bundlor/com.springsource.bundlor/1.0.0.M4/com.springsource.bundlor-1.0.0.M4.jar
# rm ivy-cache/repository/com.springsource.bundlor/com.springsource.bundlor.ant/1.0.0.M4/com.springsource.bundlor.ant-1.0.0.M4.jar
# rm ivy-cache/repository/com.springsource.osgi.medic/com.springsource.osgi.medic/1.0.0.RELEASE/com.springsource.osgi.medic-1.0.0.RELEASE.jar
# rm ivy-cache/repository/com.springsource.util/com.springsource.util.common/2.0.0.CI-R207-B131/com.springsource.util.common-2.0.0.CI-R207-B131.jar
# rm ivy-cache/repository/com.springsource.util/com.springsource.util.math/2.0.0.CI-R207-B131/com.springsource.util.math-2.0.0.CI-R207-B131.jar
# rm ivy-cache/repository/com.springsource.util/com.springsource.util.osgi/2.0.0.CI-R207-B131/com.springsource.util.osgi-2.0.0.CI-R207-B131.jar
rm ivy-cache/repository/org.apache.commons/com.springsource.org.apache.commons.logging/1.1.1/com.springsource.org.apache.commons.logging-1.1.1.jar
ln -sf $(build-classpath commons-logging) ivy-cache/repository/org.apache.commons/com.springsource.org.apache.commons.logging/1.1.1/com.springsource.org.apache.commons.logging-1.1.1.jar
rm ivy-cache/repository/org.apache.ws/com.springsource.org.apache.ws.commons.schema/1.3.2/com.springsource.org.apache.ws.commons.schema-1.3.2.jar
ln -sf $(build-classpath ws-commons-XmlSchema) ivy-cache/repository/org.apache.ws/com.springsource.org.apache.ws.commons.schema/1.3.2/com.springsource.org.apache.ws.commons.schema-1.3.2.jar
rm ivy-cache/repository/org.aspectj/com.springsource.org.aspectj.runtime/1.6.3.RELEASE/com.springsource.org.aspectj.runtime-1.6.3.RELEASE.jar
ln -sf $(build-classpath aspectjrt) ivy-cache/repository/org.aspectj/com.springsource.org.aspectj.runtime/1.6.3.RELEASE/com.springsource.org.aspectj.runtime-1.6.3.RELEASE.jar
rm ivy-cache/repository/org.aspectj/com.springsource.org.aspectj.runtime/1.6.6.RELEASE/com.springsource.org.aspectj.runtime-1.6.6.RELEASE.jar
ln -sf $(build-classpath aspectjrt) ivy-cache/repository/org.aspectj/com.springsource.org.aspectj.runtime/1.6.6.RELEASE/com.springsource.org.aspectj.runtime-1.6.6.RELEASE.jar
rm ivy-cache/repository/org.aspectj/com.springsource.org.aspectj.tools/1.6.3.RELEASE/com.springsource.org.aspectj.tools-1.6.3.RELEASE.jar
ln -sf $(build-classpath aspectjtools) ivy-cache/repository/org.aspectj/com.springsource.org.aspectj.tools/1.6.3.RELEASE/com.springsource.org.aspectj.tools-1.6.3.RELEASE.jar
rm ivy-cache/repository/org.aspectj/com.springsource.org.aspectj.weaver/1.6.3.RELEASE/com.springsource.org.aspectj.weaver-1.6.3.RELEASE.jar
ln -sf $(build-classpath aspectjweaver) ivy-cache/repository/org.aspectj/com.springsource.org.aspectj.weaver/1.6.3.RELEASE/com.springsource.org.aspectj.weaver-1.6.3.RELEASE.jar
rm ivy-cache/repository/org.easymock/com.springsource.org.easymock/2.5.1/com.springsource.org.easymock-2.5.1.jar
ln -sf $(build-classpath easymock2) ivy-cache/repository/org.easymock/com.springsource.org.easymock/2.5.1/com.springsource.org.easymock-2.5.1.jar
rm ivy-cache/repository/org.eclipse.jdt/com.springsource.org.eclipse.jdt.core.compiler.batch/3.3.0/com.springsource.org.eclipse.jdt.core.compiler.batch-3.3.0.jar
ln -sf $(build-classpath ecj3) ivy-cache/repository/org.eclipse.jdt/com.springsource.org.eclipse.jdt.core.compiler.batch/3.3.0/com.springsource.org.eclipse.jdt.core.compiler.batch-3.3.0.jar
# rm ivy-cache/repository/org.eclipse.osgi/org.eclipse.osgi/3.5.0.v20090311-1300/org.eclipse.osgi-3.5.0.v20090311-1300.jar
rm ivy-cache/repository/org.junit/com.springsource.org.junit/4.7.0/com.springsource.org.junit-4.7.0.jar
ln -sf $(build-classpath junit4) ivy-cache/repository/org.junit/com.springsource.org.junit/4.7.0/com.springsource.org.junit-4.7.0.jar
rm ivy-cache/repository/org.objectweb.asm/com.springsource.org.objectweb.asm/3.1.0/com.springsource.org.objectweb.asm-3.1.0.jar
ln -sf $(build-classpath objectweb-asm/asm) ivy-cache/repository/org.objectweb.asm/com.springsource.org.objectweb.asm/3.1.0/com.springsource.org.objectweb.asm-3.1.0.jar
rm ivy-cache/repository/org.objectweb.asm/com.springsource.org.objectweb.asm.commons/3.1.0/com.springsource.org.objectweb.asm.commons-3.1.0.jar
ln -sf $(build-classpath objectweb-asm/asm-commons) ivy-cache/repository/org.objectweb.asm/com.springsource.org.objectweb.asm.commons/3.1.0/com.springsource.org.objectweb.asm.commons-3.1.0.jar
rm ivy-cache/repository/org.objectweb.asm/com.springsource.org.objectweb.asm.tree/3.1.0/com.springsource.org.objectweb.asm.tree-3.1.0.jar
ln -sf $(build-classpath objectweb-asm/asm-tree) ivy-cache/repository/org.objectweb.asm/com.springsource.org.objectweb.asm.tree/3.1.0/com.springsource.org.objectweb.asm.tree-3.1.0.jar
rm ivy-cache/repository/org.slf4j/com.springsource.slf4j.api/1.5.10/com.springsource.slf4j.api-1.5.10.jar
ln -sf $(build-classpath slf4j/slf4j-api) ivy-cache/repository/org.slf4j/com.springsource.slf4j.api/1.5.10/com.springsource.slf4j.api-1.5.10.jar
rm ivy-cache/repository/org.slf4j/com.springsource.slf4j.nop/1.5.10/com.springsource.slf4j.nop-1.5.10.jar
ln -sf $(build-classpath slf4j/slf4j-nop) ivy-cache/repository/org.slf4j/com.springsource.slf4j.nop/1.5.10/com.springsource.slf4j.nop-1.5.10.jar
# rm ivy-cache/repository/org.springframework.build/org.springframework.build.ant/1.1.0.RELEASE/org.springframework.build.ant-1.1.0.RELEASE.jar
rm ivy-cache/repository/org.springframework/org.springframework.beans/2.5.6.A/org.springframework.beans-2.5.6.A.jar
ln -sf $(build-classpath spring2/beans) ivy-cache/repository/org.springframework/org.springframework.beans/2.5.6.A/org.springframework.beans-2.5.6.A.jar
rm ivy-cache/repository/org.springframework/org.springframework.core/2.5.6.A/org.springframework.core-2.5.6.A.jar
ln -sf $(build-classpath spring2/core) ivy-cache/repository/org.springframework/org.springframework.core/2.5.6.A/org.springframework.core-2.5.6.A.jar
# rm ivy-cache/repository/org.springframework.ws/org.springframework.xml/1.5.2.A/org.springframework.xml-1.5.2.A.jar


%build
export CLASSPATH=
CLASSPATH="$CLASSPATH:../spring-build/lib/ivy/ivy.jar"
CLASSPATH="$CLASSPATH:../spring-build/lib/ivy/org.springframework.build.aws.ivy.jar"

export ANT_OPTS="-Xmx768m -XX:MaxPermSize=128m"
export IVY_CACHE=$(pwd)/ivy-cache/repository
export IVY_LOCAL=$(pwd)/local-repository
cd build-util
%{ant} -Dlocal.repo.dir=${IVY_LOCAL} -Dtest.halt=false -Dbuild.sysclasspath=first -Djava.awt.headless=true precommit javadoc-all
%{ant} -Dlocal.repo.dir=${IVY_LOCAL} -Dtest.halt=false -Dbuild.sysclasspath=first -Djava.awt.headless=true package

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}

install -m 644 com.springsource.util.common/target/artifacts/com.springsource.util.common.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/com.springsource.util.common-%{version}.jar
install -m 644 com.springsource.util.env/target/artifacts/com.springsource.util.env.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/com.springsource.util.env-%{version}.jar
install -m 644 com.springsource.util.io/target/artifacts/com.springsource.util.io.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/com.springsource.util.io-%{version}.jar
install -m 644 com.springsource.util.jmx/target/artifacts/com.springsource.util.jmx.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/com.springsource.util.jmx-%{version}.jar
install -m 644 com.springsource.util.math/target/artifacts/com.springsource.util.math.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/com.springsource.util.math-%{version}.jar
install -m 644 com.springsource.util.osgi/target/artifacts/com.springsource.util.osgi.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/com.springsource.util.osgi-%{version}.jar
install -m 644 com.springsource.util.parser.manifest/target/artifacts/com.springsource.util.parser.manifest.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/com.springsource.util.parser.manifest-%{version}.jar
install -m 644 com.springsource.util.test/target/artifacts/com.springsource.util.test.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}/com.springsource.util.test-%{version}.jar

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc
install -m 644 com.springsource.util.common/target/artifacts/ivy.xml \
               $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/com.springsource.util.common-ivy.xml
install -m 644 com.springsource.util.env/target/artifacts/ivy.xml \
               $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/com.springsource.util.env-ivy.xml
install -m 644 com.springsource.util.io/target/artifacts/ivy.xml \
               $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/com.springsource.util.io-ivy.xml
install -m 644 com.springsource.util.jmx/target/artifacts/ivy.xml \
               $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/com.springsource.util.jmx-ivy.xml
install -m 644 com.springsource.util.math/target/artifacts/ivy.xml \
               $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/com.springsource.util.math-ivy.xml
install -m 644 com.springsource.util.osgi/target/artifacts/ivy.xml \
               $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/com.springsource.util.osgi-ivy.xml
install -m 644 com.springsource.util.parser.manifest/target/artifacts/ivy.xml \
               $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/com.springsource.util.parser.manifest-ivy.xml
install -m 644 com.springsource.util.test/target/artifacts/ivy.xml \
               $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/etc/com.springsource.util.test-ivy.xml

mkdir -p $RPM_BUILD_ROOT%{_javadir}/%{name}-sources
install -m 644 com.springsource.util.common/target/artifacts/com.springsource.util.common-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/com.springsource.util.common-sources-%{version}.jar
install -m 644 com.springsource.util.env/target/artifacts/com.springsource.util.env-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/com.springsource.util.env-sources-%{version}.jar
install -m 644 com.springsource.util.io/target/artifacts/com.springsource.util.io-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/com.springsource.util.io-sources-%{version}.jar
install -m 644 com.springsource.util.jmx/target/artifacts/com.springsource.util.jmx-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/com.springsource.util.jmx-sources-%{version}.jar
install -m 644 com.springsource.util.math/target/artifacts/com.springsource.util.math-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/com.springsource.util.math-sources-%{version}.jar
install -m 644 com.springsource.util.osgi/target/artifacts/com.springsource.util.osgi-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/com.springsource.util.osgi-sources-%{version}.jar
install -m 644 com.springsource.util.parser.manifest/target/artifacts/com.springsource.util.parser.manifest-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/com.springsource.util.parser.manifest-sources-%{version}.jar
install -m 644 com.springsource.util.test/target/artifacts/com.springsource.util.test-sources.jar \
               $RPM_BUILD_ROOT%{_javadir}/%{name}-sources/com.springsource.util.test-sources-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)
(cd $RPM_BUILD_ROOT%{_javadir}/%{name}-sources && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

%add_to_maven_depmap com.springsource.util com.springsource.util.common %{version} JPP/%{name} com.springsource.util.common
%add_to_maven_depmap com.springsource.util com.springsource.util.env %{version} JPP/%{name} com.springsource.util.env
%add_to_maven_depmap com.springsource.util com.springsource.util.io %{version} JPP/%{name} com.springsource.util.io
%add_to_maven_depmap com.springsource.util com.springsource.util.jmx %{version} JPP/%{name} com.springsource.util.jmx
%add_to_maven_depmap com.springsource.util com.springsource.util.math %{version} JPP/%{name} com.springsource.util.math
%add_to_maven_depmap com.springsource.util com.springsource.util.osgi %{version} JPP/%{name} com.springsource.util.osgi
%add_to_maven_depmap com.springsource.util com.springsource.util.parser.manifest %{version} JPP/%{name} com.springsource.util.parser.manifest
%add_to_maven_depmap com.springsource.util com.springsource.util.test %{version} JPP/%{name} com.springsource.util.test

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE11} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-com.springsource.util.common.pom
install -m 644 %{SOURCE12} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-com.springsource.util.env.pom
install -m 644 %{SOURCE13} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-com.springsource.util.io.pom
install -m 644 %{SOURCE14} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-com.springsource.util.jmx.pom
install -m 644 %{SOURCE15} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-com.springsource.util.math.pom
install -m 644 %{SOURCE16} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-com.springsource.util.osgi.pom
install -m 644 %{SOURCE17} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-com.springsource.util.parser.manifest.pom
install -m 644 %{SOURCE18} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-com.springsource.util.test.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build-util/target/javadoc-all/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}


%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}
%dir %{_javadir}/%{name}/*.jar
%dir %{_datadir}/%{name}-%{version}/etc
%{_datadir}/%{name}-%{version}/etc/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files devel
%defattr(0644,root,root,0755)
%dir %{_javadir}/%{name}-sources
%{_javadir}/%{name}-sources/*.jar

%changelog
* Fri Jun 10 2011 Ralph Apel <r.apel@r-apel.de> 0:2.0.0-1
- First release

